//|CgCg̐FiRGBj
float3 LightColor = float3(1,1,1);

//|CgCǧ(1`j
float LightPow = 1.0;



float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

//Cg`pRT
texture PointDarknessRT: OFFSCREENRENDERTARGET <
    string Description = "OffScreen RenderTarget for PostPointDarkness.fx";
    float4 ClearColor = { 0, 0, 0, 0 };
    float ClearDepth = 1.0;
    bool AntiAlias = true;
    
    string DefaultEffect = 
        "self = hide;"
        "* = RT_Model.fx;";
>;
sampler PPL_Samp = sampler_state
{
   Texture = (PointDarknessRT);
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
   FILTER = LINEAR;
};


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;

static float2 SampStep = (float2(2,2)/ViewportSize);


// _O^[Qbg̃NAl
float4 ClearColor = {1,1,1,0};
float ClearDepth  = 1.0;

// IWi̕`挋ʂL^邽߂̃_[^[Qbg

struct VS_OUTPUT {
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

VS_OUTPUT VS_Main( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ){
    VS_OUTPUT Out = (VS_OUTPUT)0; 

    Out.Pos = Pos;
    Out.Tex = Tex + ViewportOffset;

    return Out;
}

float4 PS_Main(float2 Tex: TEXCOORD0) : COLOR
{   
    float4 Color;
	Color = tex2D(PPL_Samp,Tex);
	Color.rgb = pow(Color.rgb,LightPow);
	Color.rgb *= LightColor;
    return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////

technique PostPointDarkness <
    string Script = 
	    "ScriptExternal=Color;"
        "RenderColorTarget0=;"
	    "RenderDepthStencilTarget=;"
	    //"Pass=Main;"
	    "Pass=SubMix;"
    ;
> {

    pass Main < string Script= "Draw=Buffer;"; > {
		ALPHABLENDENABLE = TRUE;
		SRCBLEND = ONE;
		DESTBLEND = ONE;
        VertexShader = compile vs_2_0 VS_Main();
        PixelShader  = compile ps_2_0 PS_Main();
    }

    pass SubMix < string Script= "Draw=Buffer;"; > {
		ALPHABLENDENABLE = TRUE;
        BLENDOP = REVSUBTRACT;
		SRCBLEND = ONE;
		DESTBLEND = ONE;
        VertexShader = compile vs_2_0 VS_Main();
        PixelShader  = compile ps_2_0 PS_Main();
    }
}
////////////////////////////////////////////////////////////////////////////////////////////////
